﻿Public Module MSettings

    Public settings As New CSettings



    Public Class CSettings

        Public back_acceleration As Integer
        Public back_deceleration As Integer
        Public back_heave_negative As Integer
        Public back_heave_positive As Integer
        Public back_neutral_position As Integer
        Public back_turn_inner As Integer
        Public back_turn_outer As Integer
        Public gseat_surge_coef As Integer
        Public gseat_sway_coef As Integer
        Public range_heave_max As Integer
        Public range_heave_min As Integer
        Public range_pitch As Integer
        Public range_roll As Integer
        Public range_surge As Integer
        Public range_surge_pitch As Integer
        Public range_sway As Integer
        Public range_sway_roll As Integer
        Public range_tl As Integer
        Public seat_acceleration As Integer
        Public seat_deceleration As Integer
        Public seat_heave_negative As Integer
        Public seat_heave_positive As Integer
        Public seat_neutral_position As Integer
        Public seat_turn_inner As Integer
        Public seat_turn_outer As Integer
        Public wind_max As Integer
        Public wind_max_car_speed As Integer
        Public wind_min As Integer


        Public Sub Read()
            back_acceleration = My.Settings.Item("back_acceleration")
            back_deceleration = My.Settings.Item("back_deceleration")
            back_heave_negative = My.Settings.Item("back_heave_negative")
            back_heave_positive = My.Settings.Item("back_heave_positive")
            back_neutral_position = My.Settings.Item("back_neutral_position")
            back_turn_inner = My.Settings.Item("back_turn_inner")
            back_turn_outer = My.Settings.Item("back_turn_outer")
            gseat_surge_coef = My.Settings.Item("gseat_surge_coef")
            gseat_sway_coef = My.Settings.Item("gseat_sway_coef")
            range_heave_max = My.Settings.Item("range_heave_max")
            range_heave_min = My.Settings.Item("range_heave_min")
            range_pitch = My.Settings.Item("range_pitch")
            range_roll = My.Settings.Item("range_roll")
            range_surge = My.Settings.Item("range_surge")
            range_surge_pitch = My.Settings.Item("range_surge_pitch")
            range_sway = My.Settings.Item("range_sway")
            range_sway_roll = My.Settings.Item("range_sway_roll")
            range_tl = My.Settings.Item("range_tl")
            seat_acceleration = My.Settings.Item("seat_acceleration")
            seat_deceleration = My.Settings.Item("seat_deceleration")
            seat_heave_negative = My.Settings.Item("seat_heave_negative")
            seat_heave_positive = My.Settings.Item("seat_heave_positive")
            seat_neutral_position = My.Settings.Item("seat_neutral_position")
            seat_turn_inner = My.Settings.Item("seat_turn_inner")
            seat_turn_outer = My.Settings.Item("seat_turn_outer")
            wind_max = My.Settings.Item("wind_max")
            wind_max_car_speed = My.Settings.Item("wind_max_car_speed")
            wind_min = My.Settings.Item("wind_min")
        End Sub


        Public Sub Write()

            My.Settings.Item("back_acceleration") = back_acceleration
            My.Settings.Item("back_deceleration") = back_deceleration
            My.Settings.Item("back_heave_negative") = back_heave_negative
            My.Settings.Item("back_heave_positive") = back_heave_positive
            My.Settings.Item("back_neutral_position") = back_neutral_position
            My.Settings.Item("back_turn_inner") = back_turn_inner
            My.Settings.Item("back_turn_outer") = back_turn_outer
            My.Settings.Item("gseat_surge_coef") = gseat_surge_coef
            My.Settings.Item("gseat_sway_coef") = gseat_sway_coef
            My.Settings.Item("range_heave_max") = range_heave_max
            My.Settings.Item("range_heave_min") = range_heave_min
            My.Settings.Item("range_pitch") = range_pitch
            My.Settings.Item("range_roll") = range_roll
            My.Settings.Item("range_surge") = range_surge
            My.Settings.Item("range_surge_pitch") = range_surge_pitch
            My.Settings.Item("range_sway") = range_sway
            My.Settings.Item("range_sway_roll") = range_sway_roll
            My.Settings.Item("range_tl") = range_tl
            My.Settings.Item("seat_acceleration") = seat_acceleration
            My.Settings.Item("seat_deceleration") = seat_deceleration
            My.Settings.Item("seat_heave_negative") = seat_heave_negative
            My.Settings.Item("seat_heave_positive") = seat_heave_positive
            My.Settings.Item("seat_neutral_position") = seat_neutral_position
            My.Settings.Item("seat_turn_inner") = seat_turn_inner
            My.Settings.Item("seat_turn_outer") = seat_turn_outer
            My.Settings.Item("wind_max") = wind_max
            My.Settings.Item("wind_max_car_speed") = wind_max_car_speed
            My.Settings.Item("wind_min") = wind_min

        End Sub

    End Class


    Public Sub SaveSettings(ByVal file_name As String)

        settings.Read()

        Dim x As New Xml.Serialization.XmlSerializer(settings.GetType)


        System.IO.File.Delete(file_name)

        Using file As System.IO.FileStream = System.IO.File.Open(file_name, IO.FileMode.OpenOrCreate, IO.FileAccess.Write)
            x.Serialize(file, settings)
        End Using

    End Sub

    Public Sub LoadSettings(ByVal file_name As String)

        Dim x As New Xml.Serialization.XmlSerializer(settings.GetType)

        Using file = System.IO.File.OpenRead(file_name)
            settings = x.Deserialize(file)
        End Using

        settings.Write()

    End Sub



End Module
