﻿Public Class ucParameterSlider

    Private parameter_name As String = ""
    Private prefix As String = ""

    Private parameter_variable As String = ""


    Private unit As String = ""


    Public Event ParameterChanged()




    Public Property UnitName As String
        Set(value As String)
            unit = value

            lblParameterValue.Text = scrollParameter.Value & " " & unit
        End Set
        Get
            Return unit
        End Get
    End Property

    Public Property ParameterName As String
        Set(value As String)
            parameter_name = value

            lblParameterName.Text = parameter_name

            Try
                parameter_variable = prefix.ToLower & "_" & parameter_name.ToLower.Replace(" ", "_")
            Catch ex As Exception
            End Try



        End Set
        Get
            Return parameter_name


        End Get
    End Property


    Public Property ParameterPrefix As String
        Set(value As String)
            prefix = value

            Try
                parameter_variable = prefix.ToLower & "_" & parameter_name.ToLower.Replace(" ", "_")
            Catch ex As Exception
            End Try

        End Set
        Get
            Return prefix
        End Get
    End Property

    Public Property ValueMin As Integer
        Set(value As Integer)
            scrollParameter.Minimum = value
        End Set
        Get
            Return scrollParameter.Minimum
        End Get
    End Property

    Public Property ValueMax As Integer
        Set(value As Integer)
            scrollParameter.Maximum = value
        End Set
        Get
            Return scrollParameter.Maximum
        End Get
    End Property

    Public Sub ShowParameter()
        scrollParameter.Value = Math.Max(Math.Min(My.Settings.Item(parameter_variable), scrollParameter.Maximum), scrollParameter.Minimum)

    End Sub


    Private Sub ucParameterSlider_Load(sender As Object, e As EventArgs) Handles Me.Load
        Call ShowParameter()
    End Sub

    Private Sub scrollParameter_ValueChanged(sender As Object, e As EventArgs) Handles scrollParameter.ValueChanged
        My.Settings.Item(parameter_variable) = scrollParameter.Value

        lblParameterValue.Text = scrollParameter.Value & " " & unit



        RaiseEvent ParameterChanged()
    End Sub
End Class
